package commissionCC

import "gitlab.smartblocklab.com/smartcontracts/common/model/userCC"

// txnProcessCommissionType
type CommissionType string

const (
	InputTransaction      CommissionType = "INPUT_TRANSACTION"
	OutputTransaction     CommissionType = "OUTPUT_TRANSACTION"
	TransactionCommission CommissionType = "TRANSACTION_COMMISSION"
	TransferToMarket      CommissionType = "TRANSFER_TO_MARKET"
)

type GetCommissionArg struct {
	PartnerCode    string              `json:"partner_code"`
	CustomerType   userCC.CustomerType `json:"customer_type"`
	CommissionType CommissionType      `json:"commission_type"`
}

func (c CommissionType) String() string {
	return string(c)
}
