package requests

import (
	"encoding/json"
	"errors"
)

type Id struct {
	Id     string `json:"id,omitempty"`
	UserId string `json:"user_id,omitempty"`
}

type ArrayId struct {
	ArrayId []Id `json:"array_id,omitempty"`
}

type PartKey struct {
	Keys []string `json:"keys,omitempty"`
}

func UnmarshalArrayId(data []byte) (*ArrayId, error) {
	var obj ArrayId
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func UnmarshalPartKey(data []byte) (*PartKey, error) {
	var obj PartKey
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func (this Id) Validate() error {
	if len(this.Id) == 0 {
		return errors.New("Id is empty")
	}

	return nil
}

func Unmarshal(data []byte) (*Id, error) {
	var obj Id
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func (this Id) Marshal() ([]byte, error) {
	return json.Marshal(this);
}
